﻿package {
	
	import flash.display.*;
	import flash.display.BitmapData;
	import flash.geom.Rectangle;
	import flash.geom.Matrix;
	import flash.events.*;
    import flash.utils.Timer;
	import flash.filters.*;
	import caurina.transitions.Tweener;
	
	public class BitmapSnapShot extends MovieClip{
		
		/*
		**@Author             Gerry Creighton - www.thespikeranch.com - 9-2008 -  gerry@thespikeranch.com
		**@Param    total     This is the total number of snap shots to display. This gets calculated by cols X rows 
		**                    which are calculated by the snapSize.
		**@Param    count     This is a copy of the uint total but is used to count down for the animations. This must be
		**                    set after the total is set so do not move.
		**@Param    posx      This is the x position of the snap shots.
		**@Param    posy      This is the y position of the snap shots.
		**@Param    snapSize  This is the size of the cube that animates. Right now the size has to be a number that 400 can easily be dived by. 
		**
		**@About              I saw a component that had this effect on an array of images and I had always wanted to create 
		**                    a similar effect but without having to store the images in my library. I also wanted to do it in Actionscript 3.
		**                    I'll have a future version of this up shortly that will cycle through an array of images rather than just 
		**                    animate snap shots of a big box. This is still a work in progress.
		*/
		
		public var box:Sprite;
		public var img:MovieClip;
		private var bitmapimg:BitmapData;
		private var pictures:Array = new Array();
		private var total:uint;
		private var count:uint = total;
		private var posx:uint;
		private var posy:uint;
        //
		private  var minuteTimer:Timer;
		private var cols:Number;
		private var rows:Number;
		private var bw:Number = 400;
		private var bh:Number = 400;
		public var snapSize:Number = 40;
		
		public function BitmapSnapShot(){
			//
			init(snapSize);
		}
		public function init(snapSize):void{
			//
			box = new Sprite();
			box.graphics.beginFill(0x000000);
			box.graphics.drawRect(0,0,bw,bh)
			box.graphics.endFill();
			box.x = 20;
			box.y = 20;
			addChild(box);
			//
			cols = box.width / snapSize;
			rows = box.height / snapSize;
			total = cols * rows;
			count = total;
			//
			bitmapimg = new BitmapData(snapSize, snapSize,false,0x000000);

			//
			for (var i:uint = 0; i < total; i++) {
				img = new MovieClip();
			    addChild(img);
				var myBitmap:Bitmap = new Bitmap(bitmapimg);
			    img.addChild(myBitmap);
				pictures.push(img);
				//
				pictures[i].x = box.x + (i % cols) * snapSize;
				pictures[i].y = box.y + Math.floor(i / rows) * snapSize;
				pictures[i].alpha = .9;
				//

				bitmapimg.draw(box);
			}
			//hide the original box
			box.visible = false;
			startAnimation();
		}
		private function startAnimation():void{
			//start a timer to animate each square off of the stage
			// creates a new Timer based on the amount of snap shots plus 1 to allow all
			// boxes to animate off the stage.
			var calcTime:Number = total+1;
            minuteTimer = new Timer(1,calcTime);
            // designates listeners for the interval and completion events
            minuteTimer.addEventListener(TimerEvent.TIMER, Animate);
            minuteTimer.addEventListener(TimerEvent.TIMER_COMPLETE, onTimerComplete);
            // starts the timer ticking
            minuteTimer.start();
		}

		private function ranDom(min:Number, max:Number):Number {
			//generates a random number between min and max
			var randomNum:Number = Math.floor(Math.random() * (max - min )) + min;
			return randomNum;
		}
		//
		private function Animate(e:TimerEvent):void {
			
			if (count >= 0) {
				var clip:MovieClip = pictures[count];
				var rot:Number = ranDom(-200, 250);
				//tween out
				Tweener.addTween(clip,{rotation:rot,time:5,transition:"linear"});
				Tweener.addTween(clip,{ y:stage.stageHeight+80,time:1.5,transition:"easeInOutBack", transitionParams:{overshoot:0.1}});
				Tweener.addTween(clip,{alpha:0,time:1,transition:"easeInQuart"});
				Tweener.addTween(clip,{_blur_blurX:10,_blur_blurY:10,time:.2,transition:"linear"});
				//
				if(count <= 0){ 
					AllDone();
				}
				count--;
				
			}
			
		}
	
		public function onTimerComplete(event:TimerEvent):void{
            //trace("Time's Up!");
			minuteTimer.stop();
			removeEventListener(TimerEvent.TIMER, Animate);
			removeEventListener(TimerEvent.TIMER_COMPLETE, onTimerComplete);
			
        }
		private function AllDone():void{
			//reset everything and take fla to 2nd frame
				count = 0;
				total = 0;
				rows = 0;
				cols = 0;
				pictures = [];
			dispatchEvent(new Event("all done animation")); 
		}
		//
	}
	//
}